#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv) {
    int opt_x = 0;		/* Option -x gesetzt? */
    int opt_n = 0;		/* Option -n gesetzt? */
    char *opt_a = NULL;		/* Option -a gesetzt? => Zeiger auf das Options-Argument */
    int errflag = 0;		/* Fehler bei der Optionsverarbeitung? */
    char c;
    int args;
    
    /*
     * verarbeite naechste Option;
     * beginne bei Index optind in argv;
     * Optionen sind x, n und a (dieses mit Parameter => ":" nach "a");
     * liefert Optionszeichen bzw. ? bei Fehler und EOF, beim Ende der
     * Optionsverarbeitung
     * (durch Setzen von opterr = 0 koennen die Fehlermeldungen von getopt()
     *  ausgeschaltet werden; im Fehlerfall - also "?" - enthaelt optopt das
     *  Zeichen, das den Fehler ausloeste)
     */
    while ((c = getopt(argc, argv, "xna:")) != EOF)
	switch (c) {	/* c enthaelt die Option bzw. ? im Fehlerfall */
	    case 'x' : opt_x = 1; break;
	    case 'n' : opt_n = 1; break;
	    case 'a' : opt_a = optarg; break;	/* optarg ist char * auf den Optionsparameter */
	    case '?' : errflag++; break;
	}

    /* optind enthaelt nun den Index des argv-Elementes, das
     * als naechstes verarbeitet werden muss/kann/darf/soll. ;-) */

    args = argc - optind; /* Anzahl noch nicht verarb. Kommandozeilenargumente */

    /* Fehlermeldung, falls nicht genau ein weiteres Kommandozeilen-Argument */
    if (args > 1)
	fprintf(stderr, "Too many arguments\n");
    else if (args < 1)
	fprintf(stderr, "Too few arguments\n");

    /* falls nicht genau ein weiteres Argument oder bei Optionsverarb. Fehler => Usage und Ende */
    if (args != 1 || errflag) {
	fprintf(stderr, "Usage: %s [-n|-x] [-a <name>] pattern\n", argv[0]);
	return 1;
    }
    
    /* Ausgabe der Optionen und des Kommandozeilen-Arguments zum Test: */
    if (opt_x)
	puts("Option -x ist gesetzt");
    if (opt_n)
	puts("Option -n ist gesetzt");
    if (opt_a)
	printf("Option -a mit Parameter \"%s\" ist gesetzt\n", opt_a);

    printf("Restliches Kommandozeilen-Argument: \"%s\"\n", argv[optind]);

    return 0;
}
