#include <stdio.h>
#include <string.h>

/*
 * Zerlegt einen String s in (mgl. leere!)
 * Tokens, die voneinander durch je ein delim-Zeichen
 * getrennt sind.
 *
 * Unterschied zu strtok(): Es sind bei strtok() mehrere
 * Trenner mgl.; ausserdem gibt's bei strtok() _keine_ leeren
 * Token
 */
char *mytok(char *s, char delim) {
    static char *old = NULL;
    char *buf = s ? s : old;	/* im Fall von s = NULL verwenden wir old! */
    if (buf == NULL)		/* am Ende? => return NULL */
        return NULL;
    if ((old = strchr(buf, delim)) != NULL) { /* noch mehr als ein Token? */
        *old = '\0';		/* Nullbyte zwischen akt. und folgendem Token einfuegen */
        old++;			/* old zeigt jetzt schon auf das folgende Token! */
    }
    return buf;
}

int main() {
    char s[] = "Dies//ist///ein/Test";	/* String mit Trenner '/' und auch leeren Tokens */
    char *token;
    int i = 0;
    
    /* Tokens wie bei strtok() extrahieren */
    token = mytok(s, '/');
    while (token) {
	printf("Token %d: \"%s\"\n", i++, token);
	token = mytok(NULL, '/');
    }
    
    return 0;
}
