#include <stdio.h>
#include <string.h>

int main(int argc, char **argv) {
    int val, anz, n;

    if (argc != 2) {
	fprintf(stderr, "Usage: %s <integer>\n", argv[0]);
	return 1;
    }
    
    /*
     * anz ist gleich die Anzahl der belegten Argumente, wobei %n nicht
     * mitgezaehlt wird - also nur 0 oder 1
     *
     * val enthaelt die Integer
     *
     * n enthaelt die Anzahl der konsumierten Zeichen
     */
    anz = sscanf(argv[1], "%d%n", &val, &n);

    fprintf(stderr, "DEBUG: val=%d anz=%d n=%d\n", val, anz, n);
    
    /*
     * Fehler, wenn val nicht belegt (anz != 1) oder noch Zeichen
     * uebrig (strlen(argv[1]) != n) sind!
     */
    if (anz != 1 || strlen(argv[1]) != n) {
	fprintf(stderr, "%s: %s: invalid integer\n", argv[0], argv[1]);
	return 2;
    }
    
    printf("Integer: %d\n", val);
    
    return 0;
}
