#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>

#define BUFLEN 128

int main() {
    char buf[BUFLEN];

    /* nun haben machen wir eine Eingabeumlenkung: die Standardeingabe
     * soll nun aus der Datei stdin.txt kommen.
     *
     * zuerst schliessen wir den FD 0; dann ist dieser der kleinste freie
     * FD; somit liefert open() genau den FD 0 beim nachfolgenden Oeffnen
     * der Datei stdin.txt
     *
     * => und somit ist die Standardeingabe umgelenkt und kommt aus der
     * Datei stdin.txt
     *
     * Bem.: gleiche Wirkung, wie wenn man das Programm umlenkung_stdin1.c
     * auf der Kommandozeile mit "< stdin.txt" aufgerufen haette!
     */
    close(0);
    if (open("stdin.txt", O_RDONLY) < 0)
	perror("stdin.txt"), exit(1);

    /* Einlesen von der Standardeingabe */
    fgets(buf, BUFLEN, stdin);
    fputs(buf, stdout);	/* ... und gleich wieder nach stdout schreiben */

    return 0;
}
